Scp (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs.optional.ssh, class: Scp

# Class Scp

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.Task
org.apache.tools.ant.taskdefs.optional.ssh.SSHBase
org.apache.tools.ant.taskdefs.optional.ssh.Scp

All Implemented Interfaces:
  `Cloneable, LogListener`

public class Scp extends SSHBase
Ant task for sending files to remote machine over ssh/scp.

Since:
  Ant 1.6

- ## Field Summary

  ### Fields inherited from class Task

  `target, taskName, taskType, wrapper`
  Modifier and Type
  Field
  Description
  `protected Target`
  `target`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskName`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskType`
  Deprecated.
  since 1.6.x.
  `protected RuntimeConfigurable`
  `wrapper`
  Deprecated.
  since 1.6.x.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Scp()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(ResourceCollection res)`
  Adds a ResourceCollection of local files to transfer to remote host.
  `void`
  `addFileset(FileSet set)`
  Adds a FileSet transfer to remote host.
  `void`
  `execute()`
  Execute this task.
  `void`
  `init()`
  Initialize this task.
  `void`
  `setCompressed(boolean compressed)`
  Sets flag to determine if compression should be used for the copy.
  `void`
  `setDirMode(String dirMode)`
  Set the dir mode, defaults to "755".
  `void`
  `setFile(String aFromUri)`
  Sets the file to be transferred.
  `void`
  `setFileMode(String fileMode)`
  Set the file mode, defaults to "644".
  `void`
  `setLocalFile(String aFromUri)`
  Similar to `setFile` but explicitly states that the file is a local file.
  `void`
  `setLocalTodir(String aToUri)`
  Similar to `setTodir` but explicitly states that the directory is a local.
  `void`
  `setLocalTofile(String aToUri)`
  Changes the file name to the given name while receiving it, only useful if receiving a single file.
  `void`
  `setPreservelastmodified(boolean yesOrNo)`
  Sets flag to determine if file timestamp is to be preserved during copy.
  `void`
  `setRemoteFile(String aFromUri)`
  Similar to `setFile` but explicitly states that the file is a remote file.
  `void`
  `setRemoteTodir(String aToUri)`
  Similar to `setTodir` but explicitly states that the directory is a remote.
  `void`
  `setRemoteTofile(String aToUri)`
  Changes the file name to the given name while sending it, only useful if sending a single file.
  `void`
  `setSftp(boolean yesOrNo)`
  Setting this to true to use sftp protocol.
  `void`
  `setTodir(String aToUri)`
  Sets the location where files will be transferred to.

  ### Methods inherited from class SSHBase

  `addConfiguredAdditionalConfig, getFailonerror, getHost, getPort, getServerAliveCountMax, getServerAliveIntervalSeconds, getSshConfig, getUserInfo, getVerbose, loadSshConfig, openSession, setFailonerror, setHost, setKeyfile, setKnownhosts, setPassphrase, setPassword, setPort, setServerAliveCountMax, setServerAliveIntervalSeconds, setSshConfig, setTrust, setUsername, setVerbose`
  Modifier and Type
  Method
  Description
  `void`
  `addConfiguredAdditionalConfig(Environment.Variable v)`
  `boolean`
  `getFailonerror()`
  Get the failonerror flag.
  `String`
  `getHost()`
  Get the host.
  `int`
  `getPort()`
  Get the port attribute.
  `int`
  `getServerAliveCountMax()`
  Get the serverAliveCountMax value.
  `int`
  `getServerAliveIntervalSeconds()`
  Get the serverAliveIntervalSeconds value in seconds.
  `String`
  `getSshConfig()`
  Get the OpenSSH config file (~/.ssh/config).
  `protected SSHUserInfo`
  `getUserInfo()`
  Get the user information.
  `boolean`
  `getVerbose()`
  Get the verbose flag.
  `protected void`
  `loadSshConfig()`
  Load the SSH configuration file.
  `protected com.jcraft.jsch.Session`
  `openSession()`
  Open an ssh session.
  `void`
  `setFailonerror(boolean failure)`
  Set the failonerror flag.
  `void`
  `setHost(String host)`
  Remote host, either DNS name or IP.
  `void`
  `setKeyfile(String keyfile)`
  Sets the keyfile for the user.
  `void`
  `setKnownhosts(String knownHosts)`
  Sets the path to the file that has the identities of all known hosts.
  `void`
  `setPassphrase(String passphrase)`
  Sets the passphrase for the users key.
  `void`
  `setPassword(String password)`
  Sets the password for the user.
  `void`
  `setPort(int port)`
  Changes the port used to connect to the remote host.
  `void`
  `setServerAliveCountMax(int countMax)`
  Set the serverAliveCountMax value.
  `void`
  `setServerAliveIntervalSeconds(int interval)`
  Set the serverAliveIntervalSeconds value in seconds.
  `void`
  `setSshConfig(String sshConfig)`
  Set the OpenSSH config file (~/.ssh/config).
  `void`
  `setTrust(boolean yesOrNo)`
  Setting this to true trusts hosts whose identity is unknown.
  `void`
  `setUsername(String username)`
  Username known to remote host.
  `void`
  `setVerbose(boolean verbose)`
  Set the verbose flag.

  ### Methods inherited from class Task

  `bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`
  Modifier and Type
  Method
  Description
  `final void`
  `bindToOwner(Task owner)`
  Bind a task to another; use this when configuring a newly created task to do work on behalf of another.
  `Target`
  `getOwningTarget()`
  Returns the container target of this task.
  `RuntimeConfigurable`
  `getRuntimeConfigurableWrapper()`
  Returns the wrapper used for runtime configuration.
  `String`
  `getTaskName()`
  Returns the name to use in logging messages.
  `String`
  `getTaskType()`
  Return the type of task.
  `protected RuntimeConfigurable`
  `getWrapper()`
  Return the runtime configurable structure for this task.
  `protected void`
  `handleErrorFlush(String output)`
  Handles an error line by logging it with the WARN priority.
  `protected void`
  `handleErrorOutput(String output)`
  Handles an error output by logging it with the WARN priority.
  `protected void`
  `handleFlush(String output)`
  Handles output by logging it with the INFO priority.
  `protected int`
  `handleInput(byte[] buffer, int offset, int length)`
  Handle an input request by this task.
  `protected void`
  `handleOutput(String output)`
  Handles output by logging it with the INFO priority.
  `protected final boolean`
  `isInvalid()`
  Has this task been marked invalid?
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(String msg, Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `maybeConfigure()`
  Configures this task - if it hasn't been done already.
  `final void`
  `perform()`
  Performs this task if it's still valid, or gets a replacement version and performs that otherwise.
  `void`
  `reconfigure()`
  Force the task to be reconfigured from its RuntimeConfigurable.
  `void`
  `setOwningTarget(Target target)`
  Sets the target container of this task.
  `void`
  `setRuntimeConfigurableWrapper(RuntimeConfigurable wrapper)`
  Sets the wrapper to be used for runtime configuration.
  `void`
  `setTaskName(String name)`
  Sets the name to use in logging messages.
  `void`
  `setTaskType(String type)`
  Sets the name with which the task has been invoked.

  ### Methods inherited from class ProjectComponent

  `clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface LogListener

  `log`
  Modifier and Type
  Method
  Description
  `void`
  `log(String message)`
  Method for the loglistener to implement to receive log messages.

- ## Constructor Details

  - ### Scp

    public Scp()

- ## Method Details

  - ### setFile

    public void setFile(String aFromUri)
    Sets the file to be transferred. This can either be a remote file or a local file. Remote files take the form:

    user:password@host:/directory/path/file.example

    Files to transfer can also include a wildcard to include all files in a remote directory. For example:

    user:password@host:/directory/path/*

    Parameters:
      `aFromUri` - a string representing the file to transfer.

  - ### setTodir

    public void setTodir(String aToUri)
    Sets the location where files will be transferred to. This can either be a remote directory or a local directory. Remote directories take the form of:

    user:password@host:/directory/path/

    This parameter is required.
    Parameters:
      `aToUri` - a string representing the target of the copy.

  - ### setLocalFile

    public void setLocalFile(String aFromUri)
    Similar to `setFile` but explicitly states that the file is a local file. This is the only way to specify a local file with a @ character.
    Parameters:
      `aFromUri` - a string representing the source of the copy.
    Since:
      Ant 1.6.2

  - ### setRemoteFile

    public void setRemoteFile(String aFromUri)
    Similar to `setFile` but explicitly states that the file is a remote file.
    Parameters:
      `aFromUri` - a string representing the source of the copy.
    Since:
      Ant 1.6.2

  - ### setCompressed

    public void setCompressed(boolean compressed)
    Sets flag to determine if compression should be used for the copy.
    Parameters:
      `compressed` - boolean
    Since:
      Ant 1.9.8

  - ### setLocalTodir

    public void setLocalTodir(String aToUri)
    Similar to `setTodir` but explicitly states that the directory is a local. This is the only way to specify a local directory with a @ character.
    Parameters:
      `aToUri` - a string representing the target of the copy.
    Since:
      Ant 1.6.2

  - ### setPreservelastmodified

    public void setPreservelastmodified(boolean yesOrNo)
    Sets flag to determine if file timestamp is to be preserved during copy.
    Parameters:
      `yesOrNo` - boolean
    Since:
      Ant 1.8.0

  - ### setRemoteTodir

    public void setRemoteTodir(String aToUri)
    Similar to `setTodir` but explicitly states that the directory is a remote.
    Parameters:
      `aToUri` - a string representing the target of the copy.
    Since:
      Ant 1.6.2

  - ### setLocalTofile

    public void setLocalTofile(String aToUri)
    Changes the file name to the given name while receiving it, only useful if receiving a single file.
    Parameters:
      `aToUri` - a string representing the target of the copy.
    Since:
      Ant 1.6.2

  - ### setRemoteTofile

    public void setRemoteTofile(String aToUri)
    Changes the file name to the given name while sending it, only useful if sending a single file.
    Parameters:
      `aToUri` - a string representing the target of the copy.
    Since:
      Ant 1.6.2

  - ### setSftp

    public void setSftp(boolean yesOrNo)
    Setting this to true to use sftp protocol.
    Parameters:
      `yesOrNo` - if true sftp protocol will be used.

  - ### setFileMode

    public void setFileMode(String fileMode)
    Set the file mode, defaults to "644".
    Parameters:
      `fileMode` - String
    Since:
      Ant 1.9.5

  - ### setDirMode

    public void setDirMode(String dirMode)
    Set the dir mode, defaults to "755".
    Parameters:
      `dirMode` - String
    Since:
      Ant 1.9.5

  - ### addFileset

    public void addFileset(FileSet set)
    Adds a FileSet transfer to remote host. NOTE: Either addFileSet() or setFile() are required. But, not both.
    Parameters:
      `set` - FileSet to send to remote host.

  - ### add

    public void add(ResourceCollection res)
    Adds a ResourceCollection of local files to transfer to remote host.
    Parameters:
      `res` - ResourceCollection to send to remote host.
    Since:
      Ant 1.9.7

  - ### init

    public void init() throws BuildException
    Initialize this task.
    Overrides:
      `init` in class `SSHBase`
    Throws:
      `BuildException` - on error

  - ### execute

    public void execute() throws BuildException
    Execute this task.
    Overrides:
      `execute` in class `Task`
    Throws:
      `BuildException` - on error